Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 15032)
@@ -20,5 +20,8 @@
 
 
-  [PushExpression(StackTypes.Integer, "INTEGER.ROT")]
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.ROT",
+    "Rotates the top 3 items of the INTEGER stack clockwise.")]
   [StorableClass]
   public class IntegerRotateExpression : RotateExpression<long> {
@@ -36,5 +39,8 @@
   }
 
-  [PushExpression(StackTypes.Float, "FLOAT.ROT")]
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.ROT",
+    "Rotates the top 3 items of the FLOAT stack clockwise.")]
   [StorableClass]
   public class FloatRotateExpression : RotateExpression<double> {
@@ -52,5 +58,8 @@
   }
 
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.ROT")]
+  [PushExpression(
+    StackTypes.Boolean,
+    "BOOLEAN.ROT",
+    "Rotates the top 3 items of the BOOLEAN stack clockwise.")]
   [StorableClass]
   public class BooleanRotateExpression : RotateExpression<bool> {
@@ -68,5 +77,8 @@
   }
 
-  [PushExpression(StackTypes.Name, "NAME.ROT")]
+  [PushExpression(
+    StackTypes.Name,
+    "NAME.ROT",
+    "Rotates the top 3 items of the NAME stack clockwise.")]
   [StorableClass]
   public class NameRotateExpression : RotateExpression<string> {
@@ -84,5 +96,9 @@
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.ROT", execIn: 3)]
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.ROT",
+    "Rotates the top 3 items of the EXEC stack clockwise.",
+    execIn: 3)]
   [StorableClass]
   public class ExecRotateExpression : RotateExpression<Expression> {
@@ -100,5 +116,8 @@
   }
 
-  [PushExpression(StackTypes.Code, "CODE.ROT")]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.ROT",
+    "Rotates the top 3 items of the CODE stack clockwise.")]
   [StorableClass]
   public class CodeRotateExpression : RotateExpression<Expression> {
@@ -116,5 +135,8 @@
   }
 
-  [PushExpression(StackTypes.Char, "CHAR.ROT")]
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.ROT",
+    "Rotates the top 3 items of the CHAR stack clockwise.")]
   [StorableClass]
   public class CharRotateExpression : RotateExpression<char> {
@@ -132,5 +154,8 @@
   }
 
-  [PushExpression(StackTypes.String, "STRING.ROT")]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.ROT",
+    "Rotates the top 3 items of the STRING stack clockwise.")]
   [StorableClass]
   public class StringRotateExpression : RotateExpression<string> {
@@ -148,5 +173,8 @@
   }
 
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].ROT")]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].ROT",
+    "Rotates the top 3 items of the INTEGER[] stack clockwise.")]
   [StorableClass]
   public class IntegerVectorRotateExpression : RotateExpression<IReadOnlyList<long>> {
@@ -164,5 +192,8 @@
   }
 
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].ROT")]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].ROT",
+    "Rotates the top 3 items of the FLOAT[] stack clockwise.")]
   [StorableClass]
   public class FloatVectorRotateExpression : RotateExpression<IReadOnlyList<double>> {
@@ -180,5 +211,8 @@
   }
 
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].ROT")]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].ROT",
+    "Rotates the top 3 items of the BOOLEAN[] stack clockwise.")]
   [StorableClass]
   public class BooleanVectorRotateExpression : RotateExpression<IReadOnlyList<bool>> {
@@ -196,5 +230,8 @@
   }
 
-  [PushExpression(StackTypes.StringVector, "STRING[].ROT")]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].ROT",
+    "Rotates the top 3 items of the STRING[] stack clockwise.")]
   [StorableClass]
   public class StringVectorRotateExpression : RotateExpression<IReadOnlyList<string>> {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs	(revision 15032)
@@ -23,5 +23,8 @@
   }
 
-  [PushExpression(StackTypes.Integer, "INTEGER.SHOVE")]
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.SHOVE",
+    "Moves the top INTEGER item to a specific stack index, whereby the index is taken from the INTEGER stack.")]
   [StorableClass]
   public class IntegerShoveExpression : ShoveExpression<long> {
@@ -39,5 +42,9 @@
   }
 
-  [PushExpression(StackTypes.Float, "FLOAT.SHOVE", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.SHOVE",
+    "Moves the top FLOAT item to a specific stack index, whereby the index is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class FloatShoveExpression : ShoveExpression<double> {
@@ -55,5 +62,9 @@
   }
 
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.SHOVE", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Boolean,
+    "BOOLEAN.SHOVE",
+    "Moves the top BOOLEAN item to a specific stack index, whereby the index is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class BooleanShoveExpression : ShoveExpression<bool> {
@@ -71,5 +82,9 @@
   }
 
-  [PushExpression(StackTypes.Name, "NAME.SHOVE", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Name,
+    "NAME.SHOVE",
+    "Moves the top NAME item to a specific stack index, whereby the index is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class NameShoveExpression : ShoveExpression<string> {
@@ -87,5 +102,10 @@
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.SHOVE", StackTypes.Integer, execIn: 1)]
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.SHOVE",
+    "Moves the top EXEC item to a specific stack index, whereby the index is taken from the INTEGER stack.",
+    StackTypes.Integer,
+    execIn: 1)]
   [StorableClass]
   public class ExecShoveExpression : ShoveExpression<Expression> {
@@ -103,5 +123,9 @@
   }
 
-  [PushExpression(StackTypes.Code, "CODE.SHOVE", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.SHOVE",
+    "Moves the top CODE item to a specific stack index, whereby the index is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class CodeShoveExpression : ShoveExpression<Expression> {
@@ -119,5 +143,9 @@
   }
 
-  [PushExpression(StackTypes.Char, "CHAR.SHOVE", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.SHOVE",
+    "Moves the top CHAR item to a specific stack index, whereby the index is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class CharShoveExpression : ShoveExpression<char> {
@@ -135,5 +163,9 @@
   }
 
-  [PushExpression(StackTypes.String, "STRING.SHOVE", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.SHOVE",
+    "Moves the top STRING item to a specific stack index, whereby the index is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class StringShoveExpression : ShoveExpression<string> {
@@ -151,5 +183,9 @@
   }
 
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].SHOVE", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].SHOVE",
+    "Moves the top INTEGER[] item to a specific stack index, whereby the index is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class IntegerVectorShoveExpression : ShoveExpression<IReadOnlyList<long>> {
@@ -167,5 +203,9 @@
   }
 
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].SHOVE", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].SHOVE",
+    "Moves the top FLOAT[] item to a specific stack index, whereby the index is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class FloatVectorShoveExpression : ShoveExpression<IReadOnlyList<double>> {
@@ -183,5 +223,9 @@
   }
 
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].SHOVE", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].SHOVE",
+    "Moves the top BOOLEAN[] item to a specific stack index, whereby the index is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class BooleanVectorShoveExpression : ShoveExpression<IReadOnlyList<bool>> {
@@ -199,5 +243,9 @@
   }
 
-  [PushExpression(StackTypes.StringVector, "STRING[].SHOVE", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].SHOVE",
+    "Moves the top STRING[] item to a specific stack index, whereby the index is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class StringVectorShoveExpression : ShoveExpression<IReadOnlyList<string>> {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs	(revision 15032)
@@ -30,5 +30,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Integer, "INTEGER.STACKDEPTH")]
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.STACKDEPTH",
+    "Pushes the stack depth onto the INTEGER stack.")]
   public class IntegerStackdepthExpression : StackdepthExpression<long> {
     public IntegerStackdepthExpression() { }
@@ -42,5 +45,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Float, "FLOAT.STACKDEPTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.STACKDEPTH",
+    "Pushes the stack depth onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class FloatStackdepthExpression : StackdepthExpression<double> {
     public FloatStackdepthExpression() { }
@@ -54,5 +61,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.STACKDEPTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Boolean,
+    "BOOLEAN.STACKDEPTH",
+    "Pushes the stack depth onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class BooleanStackdepthExpression : StackdepthExpression<bool> {
     public BooleanStackdepthExpression() { }
@@ -66,5 +77,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Name, "NAME.STACKDEPTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Name,
+    "NAME.STACKDEPTH",
+    "Pushes the stack depth onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class NameStackdepthExpression : StackdepthExpression<string> {
     public NameStackdepthExpression() { }
@@ -78,5 +93,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.STACKDEPTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.STACKDEPTH",
+    "Pushes the stack depth onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class ExecStackdepthExpression : StackdepthExpression<Expression> {
     public ExecStackdepthExpression() { }
@@ -90,5 +109,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Code, "CODE.STACKDEPTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.STACKDEPTH",
+    "Pushes the stack depth onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class CodeStackdepthExpression : StackdepthExpression<Expression> {
     public CodeStackdepthExpression() { }
@@ -102,5 +125,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Char, "CHAR.STACKDEPTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.STACKDEPTH",
+    "Pushes the stack depth onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class CharStackdepthExpression : StackdepthExpression<char> {
     public CharStackdepthExpression() { }
@@ -114,5 +141,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.STACKDEPTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.STACKDEPTH",
+    "Pushes the stack depth onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class StringStackdepthExpression : StackdepthExpression<string> {
     public StringStackdepthExpression() { }
@@ -126,5 +157,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].STACKDEPTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].STACKDEPTH",
+    "Pushes the stack depth onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class IntegerVectorStackdepthExpression : StackdepthExpression<IReadOnlyList<long>> {
     public IntegerVectorStackdepthExpression() { }
@@ -138,5 +173,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].STACKDEPTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].STACKDEPTH",
+    "Pushes the stack depth onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class FloatVectorStackdepthExpression : StackdepthExpression<IReadOnlyList<double>> {
     public FloatVectorStackdepthExpression() { }
@@ -149,5 +188,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].STACKDEPTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].STACKDEPTH",
+    "Pushes the stack depth onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class BooleanVectorStackdepthExpression : StackdepthExpression<IReadOnlyList<bool>> {
     public BooleanVectorStackdepthExpression() { }
@@ -161,5 +204,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].STACKDEPTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].STACKDEPTH",
+    "Pushes the stack depth onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class StringVectorStackdepthExpression : StackdepthExpression<IReadOnlyList<string>> {
     public StringVectorStackdepthExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatelessExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatelessExpression.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatelessExpression.cs	(revision 15032)
@@ -25,5 +25,5 @@
       get
       {
-        return ExpressionTable.TypeToAttributeTable[GetType()].ExpressionName;
+        return ExpressionTable.TypeToAttributeTable[GetType()].Name;
       }
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs	(revision 15032)
@@ -12,6 +12,13 @@
   using Stack;
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.FROMINTEGER", StackTypes.Integer)]
+  /// <summary>
+  /// Stringifies and pushes the top INTEGER.,
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.FROMINTEGER",
+    "Stringifies and pushes the top INTEGER.",
+    StackTypes.Integer)]
   public class StringFromIntegerExpression : StatelessExpression {
     public StringFromIntegerExpression() { }
@@ -30,5 +37,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.FROMFLOAT", StackTypes.Float)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.FROMFLOAT",
+    "Stringifies and pushes the top FLOAT.",
+    StackTypes.Float)]
   public class StringFromFloatExpression : StatelessExpression {
     public StringFromFloatExpression() { }
@@ -48,6 +59,13 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.FROMBOOLEAN", StackTypes.Boolean)]
+  /// <summary>
+  /// Stringifies and pushes the top BOOLEAN.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.FROMBOOLEAN",
+    "Stringifies and pushes the top BOOLEAN.",
+    StackTypes.Boolean)]
   public class StringFromBooleanExpression : StatelessExpression {
     public StringFromBooleanExpression() { }
@@ -65,6 +83,13 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.FROMCHAR", StackTypes.Char)]
+  /// <summary>
+  /// Stringifies and pushes the top CHAR.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.FROMCHAR",
+    "Stringifies and pushes the top CHAR.",
+    StackTypes.Char)]
   public class StringFromCharExpression : StatelessExpression {
     public StringFromCharExpression() { }
@@ -82,6 +107,12 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.CONCAT")]
+  /// <summary>
+  /// Concats the top 2 strings.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.CONCAT",
+    "Concats the top 2 strings.")]
   public class StringConcatExpression : StatelessExpression {
     public StringConcatExpression() { }
@@ -104,5 +135,9 @@
   /// </summary>
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.CONJCHAR", StackTypes.Char)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.CONJCHAR",
+    "Conj top CHAR onto top STRING",
+    StackTypes.Char)]
   public class StringConjCharExpression : StatelessExpression {
     public StringConjCharExpression() { }
@@ -122,6 +157,13 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.TAKE", StackTypes.Integer)]
+  /// <summary>
+  /// Same as substring 0-n, whereby n is taken from the INTEGER stack.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.TAKE",
+    "Same as substring 0-n, whereby n is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   public class StringTakeExpression : StatelessExpression {
     public StringTakeExpression() { }
@@ -145,6 +187,13 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.SUBSTRING", StackTypes.Integer)]
+  /// <summary>
+  /// Replaces top STRING with a substring from index A to B, whereby A and B are taken from the INTEGER STACK.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.SUBSTRING",
+    "Replaces top STRING with a substring from index A to B, whereby A and B are taken from the INTEGER STACK.",
+    StackTypes.Integer)]
   public class StringSubstringExpression : StatelessExpression {
     public StringSubstringExpression() { }
@@ -172,6 +221,12 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.FIRST")]
+  /// <summary>
+  /// Pushes first char of top STRING.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.FIRST",
+    "Pushes first char of top STRING.")]
   public class StringFirstExpression : StatelessExpression {
     public StringFirstExpression() { }
@@ -189,6 +244,12 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.LAST")]
+  /// <summary>
+  /// Pushes last char of top STRING.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.LAST",
+    "Pushes last char of top STRING.")]
   public class StringLastExpression : StatelessExpression {
     public StringLastExpression() { }
@@ -208,6 +269,13 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.NTH", StackTypes.Integer)]
+  /// <summary>
+  /// Pushes nth char of top STRING, whereby n is take from the INTEGER stack.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.NTH",
+    "Pushes nth char of top STRING, whereby n is take from the INTEGER stack.",
+    StackTypes.Integer)]
   public class StringNthExpression : StatelessExpression {
     public StringNthExpression() { }
@@ -229,6 +297,12 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.REST")]
+  /// <summary>
+  /// Removes first char of top STRING.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.REST",
+    "Removes first char of top STRING.")]
   public class StringRestExpression : StatelessExpression {
     public StringRestExpression() { }
@@ -247,6 +321,12 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.BUTLAST")]
+  /// <summary>
+  /// Removes last char of top STRING.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.BUTLAST",
+    "Removes last char of top STRING.")]
   public class StringButLastExpression : StatelessExpression {
     public StringButLastExpression() { }
@@ -265,6 +345,13 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.LENGTH", StackTypes.Integer)]
+  /// <summary>
+  /// Pushes length of top STRING onto the INTEGER stack.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.LENGTH",
+    "Pushes length of top STRING onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class StringLengthExpression : StatelessExpression {
     public StringLengthExpression() { }
@@ -282,6 +369,12 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.REVERSE")]
+  /// <summary>
+  /// Reverses the top STRING.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.REVERSE",
+    "Reverses the top STRING.")]
   public class StringReverseExpression : StatelessExpression {
     public StringReverseExpression() { }
@@ -300,6 +393,12 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.PARSETOCHARS")]
+  /// <summary>
+  /// Maps every char of top STRING as separate string.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.PARSETOCHARS",
+    "Maps every char of top STRING as separate string.")]
   public class StringParseToCharsExpression : StatelessExpression {
     public StringParseToCharsExpression() { }
@@ -331,6 +430,12 @@
   }
 
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.SPLIT")]
+  /// <summary>
+  /// Splits top STRING by whitespace chars.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.SPLIT",
+    "Splits top STRING by whitespace chars.")]
   public class StringSplitExpression : StatelessExpression {
     public StringSplitExpression() { }
@@ -360,8 +465,12 @@
 
   /// <summary>
-  /// True if top string is empty
-  /// </summary>
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.EMPTYSTRING", StackTypes.Boolean)]
+  /// True if top string is empty.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.EMPTYSTRING",
+    "True if top STRING is empty.",
+    StackTypes.Boolean)]
   public class StringEmptyStringExpression : StatelessExpression {
     public StringEmptyStringExpression() { }
@@ -383,5 +492,9 @@
   /// </summary>
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.CONTAINS", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.CONTAINS",
+    "True if top STRING is a substring of second STRING, false otherwise.",
+    StackTypes.Boolean)]
   public class StringContainsExpression : StatelessExpression {
     public StringContainsExpression() { }
@@ -406,5 +519,9 @@
   /// </summary>
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.CONTAINSCHAR", StackTypes.Boolean | StackTypes.Char)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.CONTAINSCHAR",
+    "True if the top CHAR is in the top STRING.",
+    StackTypes.Boolean | StackTypes.Char)]
   public class StringContainsCharExpression : StatelessExpression {
     public StringContainsCharExpression() { }
@@ -429,5 +546,9 @@
   /// </summary>
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.INDEXOFCHAR", StackTypes.Integer | StackTypes.Char)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.INDEXOFCHAR",
+    "Puts on the INTEGER stack the index of the top CHAR in the top STRING.",
+    StackTypes.Integer | StackTypes.Char)]
   public class StringIndexOfCharExpression : StatelessExpression {
     public StringIndexOfCharExpression() { }
@@ -452,5 +573,9 @@
   /// </summary>
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.OCCURRENCESOFCHAR", StackTypes.Integer | StackTypes.Char)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.OCCURRENCESOFCHAR",
+    "The number of times the top CHAR is in the top STRING.",
+    StackTypes.Integer | StackTypes.Char)]
   public class StringOccurrencesOfCharExpression : StatelessExpression {
     public StringOccurrencesOfCharExpression() { }
@@ -476,8 +601,11 @@
 
   /// <summary>
-  /// In third string on stack, replaces second string with first string
-  /// </summary>
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.REPLACE")]
+  /// In third STRING, replaces second string with first string
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.REPLACE",
+    "In third STRING, replaces second STRING with first STRING.")]
   public class StringReplaceExpression : StatelessExpression {
     public StringReplaceExpression() { }
@@ -502,8 +630,11 @@
 
   /// <summary>
-  /// In third string on stack, replaces first occurrence of second string with first string
-  /// </summary>
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.REPLACEFIRST")]
+  /// In third STRING, replaces first occurrence of second string with first string
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.REPLACEFIRST",
+    "In third STRING, replaces first occurrence of second STRING with first STRING")]
   public class StringReplaceFirstExpression : StatelessExpression {
     public StringReplaceFirstExpression() { }
@@ -533,8 +664,12 @@
 
   /// <summary>
-  /// In top string on stack, replaces all occurrences of second char with first char
-  /// </summary>
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.REPLACECHAR", StackTypes.Char)]
+  /// In top STRING, replaces all occurrences of second char with first char
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.REPLACECHAR",
+    "In top STRING, replaces all occurrences of second CHAR with first CHAR.",
+    StackTypes.Char)]
   public class StringReplaceCharExpression : StatelessExpression {
     public StringReplaceCharExpression() { }
@@ -558,8 +693,12 @@
 
   /// <summary>
-  /// In top string on stack, replaces first occurrence of second char with first char
-  /// </summary>
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.REPLACEFIRSTCHAR", StackTypes.Char)]
+  /// In top STRING, replaces first occurrence of second char with first char
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.REPLACEFIRSTCHAR",
+    "In top STRING, replaces first occurrence of second CHAR with first CHAR.",
+    StackTypes.Char)]
   public class StringReplaceFirstCharExpression : StatelessExpression {
     public StringReplaceFirstCharExpression() { }
@@ -592,8 +731,12 @@
 
   /// <summary>
-  /// In top string on stack, remove all occurrences of char
-  /// </summary>
-  [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.REMOVECHAR", StackTypes.Char)]
+  /// In top STRING, remove all occurrences of char
+  /// </summary>
+  [StorableClass]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.REMOVECHAR",
+    "In top STRING, remove all occurrences of top CHAR.",
+    StackTypes.Char)]
   public class StringRemoveCharExpression : StatelessExpression {
     public StringRemoveCharExpression() { }
@@ -617,5 +760,9 @@
   /// </summary>
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.SETCHAR", StackTypes.Char | StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.SETCHAR",
+    "Sets top CHAR at index in top STRING, whereby the index is taken from the INTEGER stack.",
+    StackTypes.Char | StackTypes.Integer)]
   public class StringSetCharExpression : StatelessExpression {
     public StringSetCharExpression() { }
@@ -651,5 +798,9 @@
   /// </summary>
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.ITERATE", StackTypes.Exec | StackTypes.Char, execIn: 1)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.ITERATE",
+    "Iterates over the top STRING using the CODE on the EXEC stack.",
+    StackTypes.Exec | StackTypes.Char, execIn: 1)]
   public class StringIterateExpression : StatelessExpression {
     public StringIterateExpression() { }
